
// Reihenfolge und Behandlung von Programmausnahmen

class Exception1 extends Exception {
  Exception1 (String text) { super (text); }
}

class Exception2 extends Exception1 {
  Exception2 (String text) { super (text); }
}

public class ExceptionDemo {
  void demo (int i) throws Exception1, Exception2, Exception {
    if (i == 1)
      throw new Exception1 ("Zusatz 1");
    else if (i == 2)
      throw new Exception2 ("Zusatz 2");
    else
      throw new Exception ("Zusatz 3");
  }

  public static void main (String args []) throws Exception {
    ExceptionDemo e = new ExceptionDemo ();
    for (int i = 1; i <= 3; i++)
      try {
        e.demo (i);
      }
      catch (Exception2 ex) {
        System.out.println (ex);
      }
      catch (Exception1 ex) {
        System.out.println (ex);
      }
      catch (Exception ex) {
        System.out.println (ex);
      }
      finally {
        System.out.println ("Abschlussbehandlung " + i);
      }
  }
}
