
// Chefs sind spezielle Personen
// Einstieg in die objektorientierte Denkweise

class Person {
  String Name;
  String Vorname;
  int PersonalNummer;
  Person (String Name, String Vorname, int PersonalNummer) {
    this.Name = Name;
    this.Vorname = Vorname;
    this.PersonalNummer = PersonalNummer;
  }
  void print () {
    System.out.print (" Name " + Name);
    System.out.print (" Vorname " + Vorname);
    System.out.print (" PersonalNummer " + PersonalNummer);
  }
}

class Chef extends Person {
  String Abteilung;
  Chef (String Name, String Vorname, int PersonalNummer, String Abteilung) {
    super (Name, Vorname, PersonalNummer);
    this.Abteilung = Abteilung;
  }
  void print () {
    super.print ();
    System.out.print (" Leitung Abteilung " + Abteilung);
  }
}

public class Personen {
  public static void main (String args[]) {
    Person personal [] = new Person[4];
    personal[0] = new Person ("Meier",   "Karl",    100);
    personal[1] = new Person ("Huber",   "Manfred", 101);
    personal[2] = new Person ("Schmidt", "Egon",    102);
    personal[3] = new Chef   ("Bauer",   "Karl",    103, "Einkauf");
    for (int i = 0; i < personal.length; i++) {
      personal[i].print ();
      System.out.println ();
    }
  }
}
